123. 买卖股票的最佳时机 III(困难)

给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。

设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。

注意:你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。

示例 1:

1
2
3
4
输入:prices = [3,3,5,0,0,3,1,4]
输出:6
解释:在第 4 天(股票价格 = 0)的时候买入,在第 6 天(股票价格 = 3)的时候卖出,这笔交易所能获得利润 = 3-0 = 3 。
随后,在第 7 天(股票价格 = 1)的时候买入,在第 8 天 (股票价格 = 4)的时候卖出,这笔交易所能获得利润 = 4-1 = 3 。

示例 2:

1
2
3
4
5
输入:prices = [1,2,3,4,5]
输出:4
解释:在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。

示例 3:

1
2
3
4
5
6
7
输入:prices = [7,6,4,3,1] 
输出:0
解释:在这个情况下, 没有交易完成, 所以最大利润为 0。
示例 4:

输入:prices = [1]
输出:0

提示:

1 <= prices.length <= 105
0 <= prices[i] <= 105

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iii

思路:

代码:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
class Solution {
public int maxProfit(int[] prices) {
int k = 2;
int n = prices.length;
//dp[i][k][j] 第i天最大,k表示第几次交易,j代表手上是否有股票
int[][][] dp = new int[n][k+1][2];
if(n<2){
return 0;
}
//base
dp[0][0][0]=0;
dp[0][0][1]=-prices[0];
dp[0][1][0]=0;
dp[0][1][1]=-prices[0];
dp[0][2][0]=0;
dp[0][2][1]=-prices[0];
for(int i=1;i<n;i++){
//只能从初始状态转换而来
dp[i][0][0]=dp[i-1][0][0];
dp[i][0][1]=Math.max(dp[i-1][0][1],dp[i-1][0][0]-prices[i]);
//后面第二个为0,是因为加上卖股票就是1了
dp[i][1][0]=Math.max(dp[i-1][1][0],dp[i-1][0][1]+prices[i]);
dp[i][1][1]=Math.max(dp[i-1][1][1],dp[i-1][1][0]-prices[i]);
//i21状态不成立
dp[i][2][0]=Math.max(dp[i-1][2][0],dp[i-1][1][1]+prices[i]);
}
//返回最大值
int a= Math.max(dp[n-1][0][0],dp[n-1][0][1]);
int b= Math.max(dp[n-1][1][0],dp[n-1][1][1]);
return Math.max(dp[n-1][2][0],Math.max(a,b));
}
}